Subject: Re: bug#58406: 29.0.50; Bars refactoring?

From: Manuel Giraud <[email-masked]>
Date: Mon, 10 Oct 2022 10:37:18 +0200

Po Lu <[email-masked]> writes:

> Manuel Giraud <[email-masked]> writes:
>
>> I'm trying to have some kind of highlight feature on the no-toolkit menu
>> bar.  As this feature is already present in tool/tab bar, I'd like to
>> mimic those.
>
> What kind of highlight?

mouse over highlight: like the relief on tool bar button or, even
better, with highlight face like on the modeline.

>> +enum bar_type
>> +  {
>> +    MENU_BAR,
>> +    TAB_BAR,
>> +    TOOL_BAR
>> +  };
>
> These enums are definitely named too generally.  They could conflict
> with other libraries down the road.

Ok.

[...]

> Why ENUM_BF?

A mistake.  I thought it was the way to use enum types in emacs.

> BTW, I really don't recommend doing this kind of refactoring so close to
> cutting the Emacs 29 branch.  Last year I and Alan Third found and fixed
> several obscure bugs related to the tab bar code being a poor cargo cult
> of the tool bar code, introducing subtle differences between both pieces
> of code.  Any refactoring there is likely to introduce more bugs, or to
> reintroduce old ones, and those bugs are much too subtle to find before
> November (or even February.)

I understand that it is too close to Emacs 29.  Do you think the menu
bar could be made to mimic some feature of the tool bar (like tab bar
did)?  Or do you think it would add to the cargo cult?
-- 
Manuel Giraud